using System.CodeDom.Compiler;
using System.Data;

namespace SubSonic
{
	public interface ICodeLanguage
	{
		#region Properties

		string CodeProvider { get; }
		string FileExtension { get; }
		string TemplatePrefix { get; }
		string Identifier { get; }
		string ShortName { get; }
        string DefaultUsingStatements { get; }
		#endregion

		#region Methods

		CodeDomProvider CreateCodeProvider();
		string GetDefaultValue(string colName, DbType dbType, bool isNullableColumn);
		string GetUsingStatements(string[] namespaces);
		string GetVariableType(DbType dbType, bool isNullableColumn);
		bool IsKeyword(string word);

		#endregion
	}
}
