using System;

namespace SubSonic
{
	public class GenericConstraint : IConstraint
	{
		public GenericConstraint(Comparison comparison, object value)
		{
			this.comparison = comparison;
			this.value = value;
		}

		private readonly Comparison comparison;
		private readonly object value;

		/// <summary>
		/// The type of comparison represented by this 
		/// constraint.
		/// </summary>
		public Comparison Comparison
		{
			get { return comparison; }
		}

		/// <summary>
		/// The value of the constraint. This is what 
		/// is being compared.
		/// </summary>
		public object Value
		{
			get { return value; }
		}
	}
}
