using System;

namespace SubSonic
{
	/// <summary>
	/// This is a syntax helper for constraint based querying.
	/// </summary>
	public static class Is
	{
		/// <summary>
		/// Equals to.
		/// </summary>
		/// <param name="comparand">The comparand.</param>
		/// <returns></returns>
		public static IConstraint EqualTo(object comparand)
		{
			return new GenericConstraint(Comparison.Equals, comparand);
		}

		/// <summary>
		/// Not Equals to.
		/// </summary>
		/// <param name="comparand">The comparand.</param>
		/// <returns></returns>
		public static IConstraint NotEqualTo(object comparand)
		{
			return new GenericConstraint(Comparison.NotEquals, comparand);
		}

		/// <summary>
		/// Like
		/// </summary>
		/// <param name="comparand">The comparand.</param>
		/// <returns></returns>
		public static IConstraint Like(object comparand)
		{
			return new GenericConstraint(Comparison.Like, comparand);
		}

		/// <summary>
		/// Not Like
		/// </summary>
		/// <param name="comparand">The comparand.</param>
		/// <returns></returns>
		public static IConstraint NotLike(object comparand)
		{
			return new GenericConstraint(Comparison.NotLike, comparand);
		}

		/// <summary>
		/// Less than 
		/// </summary>
		/// <param name="comparand"></param>
		/// <returns></returns>
		public static IConstraint LessThan(object comparand)
		{
			return new GenericConstraint(Comparison.LessThan, comparand);
		}

		/// <summary>
		/// Less than or equal to.
		/// </summary>
		/// <param name="comparand"></param>
		/// <returns></returns>
		public static IConstraint LessThanOrEqualTo(object comparand)
		{
			return new GenericConstraint(Comparison.LessOrEquals, comparand);
		}

		/// <summary>
		/// Greater than 
		/// </summary>
		/// <param name="comparand"></param>
		/// <returns></returns>
		public static IConstraint GreaterThan(object comparand)
		{
			return new GenericConstraint(Comparison.GreaterThan, comparand);
		}

		/// <summary>
		/// Less than or equal to.
		/// </summary>
		/// <param name="comparand"></param>
		/// <returns></returns>
		public static IConstraint GreaterThanOrEqualTo(object comparand)
		{
			return new GenericConstraint(Comparison.GreaterOrEquals, comparand);
		}
	}
}
