''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Code author: Martin Lapierre, http://devinstinct.com
''''''''''''''''''''''''''''''''''''''''''''''''''''''

Imports System.IO
Imports EnvDTE

Namespace SubSonic.Tools

    Public Class ProjectInfo
        Inherits ItemInfo

        Private _project As Project

        Public Sub New(ByVal project As Project)
            If (project Is Nothing) Then
                Throw New ArgumentNullException("project")
            End If
            _project = project
        End Sub
        Public Overrides ReadOnly Property FileName() As String
            Get
                Return _project.FileName
            End Get
        End Property

        Public Overrides ReadOnly Property RelatedProjectItems() As EnvDTE.ProjectItems
            Get
                Return _project.ProjectItems
            End Get
        End Property

        Public Overrides ReadOnly Property Kind() As String
            Get
                Return _project.Kind
            End Get
        End Property

        Public Overrides ReadOnly Property Name() As String
            Get
                If (String.IsNullOrEmpty(Path.GetFileName(_project.FileName))) Then
                    ' Web Application Projects don't have a nice name; make one.
                    Dim pathParts As String() = _project.FileName.Split(New Char() {Path.DirectorySeparatorChar}, StringSplitOptions.RemoveEmptyEntries)
                    Return pathParts(pathParts.Length - 1)
                Else
                    Return _project.Name
                End If
            End Get
        End Property

        Public Overrides ReadOnly Property Project() As EnvDTE.Project
            Get
                Return _project
            End Get
        End Property
    End Class

End Namespace
