''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Code author: Martin Lapierre, http://devinstinct.com
''''''''''''''''''''''''''''''''''''''''''''''''''''''

Imports EnvDTE

Namespace SubSonic.Tools

    Public Class ProjectItemInfo
        Inherits ItemInfo

        Private _projectItem As ProjectItem = Nothing

        Public Sub New(ByVal projectItem As ProjectItem)
            If (projectItem Is Nothing) Then
                Throw New ArgumentNullException("projectItem")
            End If
            _projectItem = projectItem
        End Sub



        Public Overrides ReadOnly Property FileName() As String
            Get
                Return _projectItem.FileNames(1)
            End Get
        End Property

        Public Overrides ReadOnly Property RelatedProjectItems() As EnvDTE.ProjectItems
            Get
                If (_projectItem.ProjectItems Is Nothing) Then
                    Return _projectItem.Collection
                Else
                    Return _projectItem.ProjectItems
                End If
            End Get
        End Property

        Public Overrides ReadOnly Property Kind() As String
            Get
                Return _projectItem.Kind
            End Get
        End Property

        Public Overrides ReadOnly Property Name() As String
            Get
                Return _projectItem.Name
            End Get
        End Property

        Public Overrides ReadOnly Property Project() As EnvDTE.Project
            Get
                Return _projectItem.ContainingProject
            End Get
        End Property
    End Class

End Namespace
