Imports System.Windows.Forms

Public Class SelectBox

	Private _title As String
	Public Delegate Sub SimpleEvent()
	Public Activated As SimpleEvent

	Public Property Title() As String
		Get
			Return Me._title
		End Get
		Set(ByVal value As String)
			Me._title = value
			Me._label.Text = _title
		End Set
	End Property

	Public Sub InitCheckListBox(ByVal items As String(), ByVal selectedItems As String())

		_list.Items.Clear()
		_list.Items.AddRange(items)
		If items.Length = 0 Then
			_list.Parent.Enabled = False
		Else
			_list.Parent.Enabled = True
			If (selectedItems IsNot Nothing) Then
				If (selectedItems(0) = "*") Then
					CheckedListBoxSelectAll(_list)
				Else
					For Each selectedItem As String In selectedItems
						_list.SetItemChecked(_list.FindStringExact(selectedItem), True)
					Next
				End If
			End If
		End If

	End Sub

	Public Function GetSelection() As String()
		If (_list.CheckedItems.Count <> 0) Then
			Dim selection As String()
			If (_list.CheckedItems.Count = _list.Items.Count) Then
				ReDim selection(0)
				selection(0) = "*"
			Else
				ReDim selection(_list.CheckedItems.Count - 1)
				For iChecked As Integer = 0 To _list.CheckedItems.Count - 1
					selection(iChecked) = _list.CheckedItems(iChecked)
				Next
			End If
			Return selection
		Else
			Return Nothing
		End If
	End Function

   Private Sub CheckedListBoxSelectAll(ByVal listBox As CheckedListBox)
      For iList As Integer = 0 To listBox.Items.Count - 1
         listBox.SetItemChecked(iList, True)
      Next
   End Sub

   Private Sub CheckedListBoxClearAll(ByVal listBox As CheckedListBox)
      For iList As Integer = 0 To listBox.Items.Count - 1
         listBox.SetItemChecked(iList, False)
      Next
   End Sub

   Private Sub _selectAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _selectAll.Click, _selectAll.Click
		CheckedListBoxSelectAll(Me._list)
		InvokeActivated()
	End Sub

   Private Sub _clearAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _clearAll.Click, _clearAll.Click
		CheckedListBoxClearAll(Me._list)
		InvokeActivated()
	End Sub

	Private Sub _list_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _list.SelectedIndexChanged
		InvokeActivated()
	End Sub

	Private Sub InvokeActivated()
		If (Activated IsNot Nothing) Then
			Activated.Invoke()
		End If
	End Sub
End Class
